/* Copyright © 2002 Red Hat, Inc.
 *
 * Permission to use, copy, modify, distribute, and sell this software and its
 * documentation for any purpose is hereby granted without fee, provided that
 * the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name of Red Hat not be used in advertising or
 * publicity pertaining to distribution of the software without specific,
 * written prior permission.  Red Hat makes no representations about the
 * suitability of this software for any purpose.  It is provided "as is"
 * without express or implied warranty.
 *
 * RED HAT DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL RED HAT
 * BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION
 * OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN 
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Author:  Owen Taylor <otaylor@redhat.com>
 */

#ifdef REVERSE
#define GET(s,i) FbGet8(s,16-i)
#else
#define GET(s,i) FbGet8(s,i)
#endif

#ifdef PREMULT
#define COMPOSE(i,t1,t2)				\
	  (t2 = GET(s,i) + ((t1 + (t1 >> 8)) >> 8),	\
	   (t2 | (0 - (t2 >> 8))))
#else
#define COMPOSE(i,t1,t2)					\
	  (t2 = a * GET(s,i) + 0x80,				\
           ((t1 + (t1 >> 8)) >> 8) + ((t2 + (t2 >> 8)) >> 8))
#endif

static CARD16
NAME (CARD32 s,
      CARD16 d)
{
  CARD32 tr0, tg0, tb0;
  CARD32 tr1, tg1, tb1;
  CARD32 tr2, tg2, tb2;
  CARD32 tr3, tg3, tb3;
  CARD8 a = s >> 24;

  tr0 = (d & 0xf800);
  tr1 = (255 - a) * ((tr0 >> 8) + (tr0 >> 13)) + 0x80;
  tr3 = COMPOSE(16,tr1,tr2);
  
  tg0 = (d & 0x07e0);
  tg1 = (255 - a) * ((tg0 >> 3) + (tg0 >> 9)) + 0x80;
  tg3 = COMPOSE(8,tg1,tg2);
  
  tb0 = (d & 0x001f);
  tb1 = (255 - a) * ((tb0 << 3) + (tb0 >> 2)) + 0x80;
  tb3 = COMPOSE(0,tb1,tb2);
  
  return (((tr3 & 0xf8) << 8) | ((tg3 & 0xfc) << 3) | ((tb3 >> 3)));
}

#undef GET
#undef COMPOSE
