/* Copyright © 2002 Red Hat, Inc.
 *
 * Permission to use, copy, modify, distribute, and sell this software and its
 * documentation for any purpose is hereby granted without fee, provided that
 * the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name of Red Hat not be used in advertising or
 * publicity pertaining to distribution of the software without specific,
 * written prior permission.  Red Hat makes no representations about the
 * suitability of this software for any purpose.  It is provided "as is"
 * without express or implied warranty.
 *
 * RED HAT DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL RED HAT
 * BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION
 * OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN 
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Author:  Owen Taylor <otaylor@redhat.com>
 */

void
NAME  (CARD8 *src_buf,
       int    src_rowstride,
       CARD8 *dest_buf,
       int    dest_rowstride,
       int    width,
       int    height)
{
  CARD8 *src = src_buf;
  CARD8 *dest = dest_buf;

  MMXPrepare();

  while (height--)
    {
      int twidth = width;
      CARD8 *p = src;
      CARD8 *q = dest;

      while (twidth--)
	{
	  __asm__ __volatile__ (Load8888("%1", "%%mm4")
				OVER("%0", "%%mm4","%%mm5","%%mm6","%%mm7", "%2")
				"packuswb %%mm4, %%mm4\n\t"
				"movd %%mm4, %1"
				: /* no output */
				: "m" (*p), "m" (*q), "r" (mmx_constants));

	  p += 4;
	  q += 4;
	}
      
      src += src_rowstride;
      dest += dest_rowstride;
    }

  __asm__ __volatile__ ("emms");
}
